//
//  MenuLayer.swift
//  SchoolhouseSkateboarder
//
//  Created by MATTHEW MCCARTHY on 4/9/17.
//  Copyright © 2017 iOS Kids. All rights reserved.
//

import SpriteKit

class MenuLayer: SKSpriteNode {
    
    // Vertelt het MenuLayer dat het een bericht moet weergeven en optioneel een score moet tonen
    func display(message: String, score: Int?) {
        
        // Create a message label using the passed-in message
        let messageLabel: SKLabelNode = SKLabelNode(text: message)
        
        // Stel de startpositie van het label in op links van de menulaag
        let messageX = -frame.width
        let messageY = frame.height / 2.0
        messageLabel.position = CGPoint(x: messageX, y: messageY)
        
        messageLabel.horizontalAlignmentMode = .center
        messageLabel.fontName = "Courier-Bold"
        messageLabel.fontSize = 48.0
        messageLabel.zPosition = 20
        self.addChild(messageLabel)
        
        // Animeer het berichtlabel op het midden van het scherm
        let finalX = frame.width / 2.0
        let messageAction = SKAction.moveTo(x: finalX, duration: 0.3)
        messageLabel.run(messageAction)
        
        // Als een score is bereikt binnen de methode, toon het dan
        if let scoreToDisplay = score {
            
            // Maak de scoretekst van de score Int
            let scoreString = String(format: "Score: %04d", scoreToDisplay)
            let scoreLabel: SKLabelNode = SKLabelNode(text: scoreString)
            
            // Stel de startpositie van het label in op rechts van de menulaag
            let scoreLabelX = frame.width
            let scoreLabelY = messageLabel.position.y - messageLabel.frame.height
            scoreLabel.position = CGPoint(x: scoreLabelX, y: scoreLabelY)
            
            scoreLabel.horizontalAlignmentMode = .center
            scoreLabel.fontName = "Courier-Bold"
            scoreLabel.fontSize = 32.0
            scoreLabel.zPosition = 20
            addChild(scoreLabel)
            
            // Animeer het scorelabel in het midden van het scherm
            let scoreAction = SKAction.moveTo(x: finalX, duration: 0.3)
            scoreLabel.run(scoreAction)
        }
    }
}
